import { ConstEnv } from "@/constants/ConstEnv";
import Styles from "@/constants/Styles";
import { apiDeleteTaskMember, apiGetTaskOne } from "@/lib/api";
import { setUpdateTask } from "@/lib/taskUpdate";
import { useAuthSession } from "@/providers/AuthProvider";
import { MaterialCommunityIcons } from "@expo/vector-icons";
import { router, useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";
import AlertKonfirmasi from "../alertKonfirmasi";
import BorderBottomItem from "../borderBottomItem";
import DrawerBottom from "../drawerBottom";
import ImageUser from "../imageNew";
import MenuItemRow from "../menuItemRow";
import SkeletonTwoItem from "../skeletonTwoItem";
import Text from "../Text";

type Props = {
   id: string;
   idUser: string;
   name: string;
   email: string;
   img: string;
   position: string;
};

export default function SectionMemberTask({ refreshing, isMemberDivision }: { refreshing: boolean, isMemberDivision: boolean }) {
   const [isModal, setModal] = useState(false);
   const entityUser = useSelector((state: any) => state.user);
   const { token, decryptToken } = useAuthSession();
   const { id, detail } = useLocalSearchParams<{ id: string; detail: string }>();
   const [data, setData] = useState<Props[]>([]);
   const dispatch = useDispatch();
   const update = useSelector((state: any) => state.taskUpdate);
   const [loading, setLoading] = useState(true)
   const arrSkeleton = Array.from({ length: 3 })
   const [memberChoose, setMemberChoose] = useState({
      id: "",
      name: "",
   });

   async function handleLoad(loading: boolean) {
      try {
         setLoading(loading)
         const hasil = await decryptToken(String(token?.current));
         const response = await apiGetTaskOne({
            id: detail,
            user: hasil,
            cat: "member",
         });
         setData(response.data);
      } catch (error) {
         console.error(error);
      } finally {
         setLoading(false)
      }
   }

   useEffect(() => {
      handleLoad(false);
   }, [update.member]);

   useEffect(() => {
      handleLoad(true);
   }, [])

   useEffect(() => {
      if (refreshing)
         handleLoad(false);
   }, [refreshing]);

   async function handleDeleteMember() {
      try {
         const hasil = await decryptToken(String(token?.current));
         const response = await apiDeleteTaskMember({
            user: hasil,
            idUser: memberChoose.id,
         }, detail)
         if (response.success) {
            Toast.show({ type: 'small', text1: 'Berhasil menghapus anggota', })
            dispatch(setUpdateTask({ ...update, member: !update.progress }))
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error) {
         console.error(error);
         Toast.show({ type: 'small', text1: 'Gagal menghapus anggota', })
      } finally {
         setModal(false);
      }
   }

   return (
      <>
         <View style={[Styles.mb15]}>
            <View style={[Styles.rowSpaceBetween, Styles.mv05]}>
               <Text style={[Styles.textDefaultSemiBold]}>Anggota</Text>
               <Text style={[Styles.textDefault]}>Total {data.length} Anggota</Text>
            </View>

            <View style={[Styles.wrapPaper]}>
               {
                  loading ?
                     arrSkeleton.map((item, index) => {
                        return (
                           <SkeletonTwoItem key={index} />
                        )
                     })
                     :
                     data.length > 0 ? (
                        data.map((item, index) => {
                           return (
                              <BorderBottomItem
                                 key={index}
                                 borderType="bottom"
                                 icon={
                                    <ImageUser src={`${ConstEnv.url_storage}/files/${item.img}`} />
                                 }
                                 title={item.name}
                                 onPress={() => {
                                    setMemberChoose({
                                       id: item.idUser,
                                       name: item.name,
                                    });
                                    setModal(true);
                                 }}
                              />
                           );
                        })
                     ) : (
                        <Text
                           style={[
                              Styles.textDefault,
                              Styles.cGray,
                              { textAlign: "center" },
                           ]}
                        >
                           Tidak ada anggota
                        </Text>
                     )
               }
            </View>
         </View>

         <DrawerBottom
            animation="slide"
            isVisible={isModal}
            setVisible={setModal}
            title={memberChoose.name}
         >
            <View style={Styles.rowItemsCenter}>
               <MenuItemRow
                  icon={
                     <MaterialCommunityIcons
                        name="account-eye"
                        color="black"
                        size={25}
                     />
                  }
                  title="Lihat Profil"
                  onPress={() => {
                     setModal(false);
                     router.push(`/member/${memberChoose.id}`);
                  }}
               />


               {
                  (entityUser.role != "user" && entityUser.role != "coadmin") || isMemberDivision
                     ?
                     <MenuItemRow
                        icon={
                           <MaterialCommunityIcons
                              name="account-remove"
                              color="black"
                              size={25}
                           />
                        }
                        title="Keluarkan"
                        onPress={() => {
                           setModal(false)
                           AlertKonfirmasi({
                              title: "Konfirmasi",
                              desc: "Apakah Anda yakin ingin mengeluarkan anggota?",
                              onPress: () => { handleDeleteMember() },
                           });
                        }}
                     />
                     :
                     <></>
               }
            </View>
         </DrawerBottom>
      </>
   );
}
